package juliac.generated;

import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import java.util.HashMap;
import java.util.HashSet;
import org.objectweb.fractal.julia.loader.Initializable;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import java.util.Iterator;
import org.objectweb.util.monolog.api.Level;
import org.objectweb.dream.control.logger.Loggable;
import org.objectweb.util.monolog.api.Logger;
import org.objectweb.dream.control.logger.LoggerController;
import org.objectweb.dream.control.logger.LoggerControllerRegister;
import java.util.Map;
import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.MonologFactory;
import org.objectweb.fractal.api.control.NameController;
import java.util.Set;
import org.objectweb.fractal.julia.loader.Tree;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin
 * @see org.objectweb.fractal.julia.BasicInitializableMixin
 * @see org.objectweb.dream.control.logger.BasicLoggerControllerMixin
 */
public class LoggerControllerImpl implements LoggerController , LoggerControllerRegister , Controller , Generated , Initializable {
    /** 
     * @see org.objectweb.fractal.julia.BasicInitializableMixin#initialize(org.objectweb.fractal.julia.loader.Tree)
     */
    private void initialize$0(final Tree args) throws Exception {
    }
    
    /** 
     * @see org.objectweb.dream.control.logger.BasicLoggerControllerMixin#baseName
     */
    String baseName;
    
    /** 
     * @see org.objectweb.dream.control.logger.BasicLoggerControllerMixin#registrations
     */
    Map<java.lang.String, java.util.Set<org.objectweb.dream.control.logger.Loggable>>  registrations;
    
    /** 
     * @see org.objectweb.dream.control.logger.BasicLoggerControllerMixin#loggers
     */
    Map<java.lang.String, org.objectweb.util.monolog.api.Logger>  loggers;
    
    /** 
     * @see org.objectweb.dream.control.logger.BasicLoggerControllerMixin#baseLogger
     */
    Logger baseLogger;
    
    /** 
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$1(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin#weaveableOptNC
     */
    public NameController weaveableOptNC;
    
    /** 
     * @see org.objectweb.dream.control.logger.BasicLoggerControllerMixin#initialize(org.objectweb.fractal.julia.loader.Tree)
     */
    public void initialize(final Tree args) throws Exception {
        initialize$0(args);
        for (int i = 0 ; i < (args.getSize()) ; ++i) {
            Tree arg = args.getSubTree(i);
            if (((arg.getSize()) == 2) && (arg.getSubTree(0).equals("monolog-conf-file"))) {
                String monologConfFile = arg.getSubTree(1).toString();
                if ((Monolog.monologFactory) == (Monolog.getDefaultMonologFactory())) {
                    Monolog.getMonologFactory(monologConfFile);
                } 
            } 
        }
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
        weaveableOptNC = ((NameController)(ic.getOptionalInterface("name-controller")));
        initFcController$1(ic);
    }
    
    /** 
     * @see org.objectweb.dream.control.logger.BasicLoggerControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(InitializationContext ic) throws InstantiationException {
        initFcController$0(ic);
        baseName = org.objectweb.dream.control.logger.Util.getNextUnnamedBaseName();
        registrations = new HashMap<java.lang.String, java.util.Set<org.objectweb.dream.control.logger.Loggable>> ();
        loggers = new HashMap<java.lang.String, org.objectweb.util.monolog.api.Logger> ();
    }
    
    /** 
     * @see org.objectweb.dream.control.logger.BasicLoggerControllerMixin#getBaseName()
     */
    public String getBaseName() {
        return baseName;
    }
    
    /** 
     * @see org.objectweb.dream.control.logger.BasicLoggerControllerMixin#setBaseName(java.lang.String)
     */
    public void setBaseName(String name) {
        this.baseName = name;
        baseNameChanged();
    }
    
    /** 
     * @see org.objectweb.dream.control.logger.BasicLoggerControllerMixin#getLoggerLevel(java.lang.String)
     */
    public int getLoggerLevel(String loggerName) {
        Logger l = loggers.get(loggerName);
        if (l == null) {
            if (loggerName == null) {
                if ((baseLogger) == null) {
                    baseLogger = Monolog.monologFactory.getLogger(baseName);
                } 
                l = baseLogger;
            } else {
                return LoggerController.INHERIT;
            }
        } 
        int i = l.getCurrentIntLevel();
        if (i == (BasicLevel.DEBUG))
            return LoggerController.DEBUG;
        
        if (i == (BasicLevel.INFO))
            return LoggerController.INFO;
        
        if (i == (BasicLevel.WARN))
            return LoggerController.WARN;
        
        if (i == (BasicLevel.ERROR))
            return LoggerController.ERROR;
        
        if (i == (BasicLevel.FATAL))
            return LoggerController.FATAL;
        
        if (i == (BasicLevel.INHERIT))
            return LoggerController.INHERIT;
        
        throw new IllegalStateException(("Unknown logger level : " + i));
    }
    
    /** 
     * @see org.objectweb.dream.control.logger.BasicLoggerControllerMixin#setLoggerLevel(java.lang.String,int)
     */
    public void setLoggerLevel(String loggerName, int level) {
        Logger l = loggers.get(loggerName);
        if (l == null) {
            if (loggerName == null) {
                if ((baseLogger) == null) {
                    baseLogger = Monolog.monologFactory.getLogger(baseName);
                } 
                l = baseLogger;
            } else {
                return ;
            }
        } 
        switch (level) {
            case LoggerController.DEBUG :
                l.setLevel(BasicLevel.LEVEL_DEBUG);
                break;
            case LoggerController.INFO :
                l.setLevel(BasicLevel.LEVEL_INFO);
                break;
            case LoggerController.WARN :
                l.setLevel(BasicLevel.LEVEL_WARN);
                break;
            case LoggerController.ERROR :
                l.setLevel(BasicLevel.LEVEL_ERROR);
                break;
            case LoggerController.FATAL :
                l.setLevel(BasicLevel.LEVEL_FATAL);
                break;
            case LoggerController.INHERIT :
                l.setLevel(BasicLevel.LEVEL_INHERIT);
                break;
            default :
                throw new IllegalArgumentException(("Unknown level " + level));
        }
    }
    
    /** 
     * @see org.objectweb.dream.control.logger.BasicLoggerControllerMixin#getLoggerNames()
     */
    public String[] getLoggerNames() {
        return loggers.keySet().toArray(new String[loggers.size()]);
    }
    
    /** 
     * @see org.objectweb.dream.control.logger.BasicLoggerControllerMixin#register(java.lang.String,org.objectweb.dream.control.logger.Loggable)
     */
    public void register(String loggerName, Loggable loggable) {
        Set<org.objectweb.dream.control.logger.Loggable>  s = registrations.get(loggerName);
        if (s == null) {
            s = new HashSet<org.objectweb.dream.control.logger.Loggable> ();
            registrations.put(loggerName ,s);
        } 
        s.add(loggable);
        giveLogger(loggerName ,loggable);
    }
    
    /** 
     * @see org.objectweb.dream.control.logger.BasicLoggerControllerMixin#unregiser(java.lang.String,org.objectweb.dream.control.logger.Loggable)
     */
    public void unregiser(String loggerName, Loggable loggable) {
        Set<org.objectweb.dream.control.logger.Loggable>  s = registrations.get(loggerName);
        if (s == null) {
            return ;
        } 
        s.remove(loggable);
        if (s.isEmpty()) {
            registrations.remove(loggerName);
            loggers.remove(loggerName);
        } 
    }
    
    /** 
     * @see org.objectweb.dream.control.logger.BasicLoggerControllerMixin#baseNameChanged()
     */
    void baseNameChanged() {
        loggers.clear();
        Iterator<java.util.Map.Entry<java.lang.String, java.util.Set<org.objectweb.dream.control.logger.Loggable>>>  iter = registrations.entrySet().iterator();
        while (iter.hasNext()) {
            Map.Entry<java.lang.String, java.util.Set<org.objectweb.dream.control.logger.Loggable>>  entry = iter.next();
            String loggerName = entry.getKey();
            Set<org.objectweb.dream.control.logger.Loggable>  loggables = entry.getValue();
            Iterator<org.objectweb.dream.control.logger.Loggable>  iter2 = loggables.iterator();
            while (iter2.hasNext()) {
                Loggable loggable = iter2.next();
                giveLogger(loggerName ,loggable);
            }
        }
    }
    
    /** 
     * @see org.objectweb.dream.control.logger.BasicLoggerControllerMixin#giveLogger(java.lang.String,org.objectweb.dream.control.logger.Loggable)
     */
    void giveLogger(String loggerName, Loggable loggable) {
        Logger logger = loggers.get(loggerName);
        if (logger == null) {
            String name;
            if (loggerName == null) {
                name = baseName;
            } else {
                name = ((baseName) + ".") + loggerName;
            }
            logger = Monolog.monologFactory.getLogger(name);
            loggers.put(loggerName ,logger);
        } 
        loggable.setLogger(loggerName ,logger);
    }
    
    private void initFcController$2(InitializationContext ic) throws InstantiationException {
    }
    
    private void initialize$1(final Tree args) throws Exception {
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.LoggerControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.objectweb.fractal.julia.control.name.UseNameControllerMixin org.objectweb.fractal.julia.BasicInitializableMixin org.objectweb.dream.control.logger.BasicLoggerControllerMixin)";
    }
    
}

