package juliac.generated;

import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import java.util.HashMap;
import org.objectweb.dream.control.activity.task.IllegalTaskException;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.control.LifeCycleController;
import org.objectweb.dream.control.logger.Loggable;
import org.objectweb.util.monolog.api.Logger;
import org.objectweb.dream.control.logger.LoggerController;
import org.objectweb.dream.control.logger.LoggerControllerRegister;
import java.util.Map;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.dream.control.activity.task.NoSuchTaskException;
import org.objectweb.dream.util.NullLogger;
import java.util.Set;
import org.objectweb.dream.control.activity.task.Task;
import org.objectweb.dream.control.activity.task.TaskActivationController;
import org.objectweb.dream.control.activity.task.TaskActivationStoppedListener;
import org.objectweb.dream.control.activity.task.TaskController;
import org.objectweb.dream.control.activity.manager.TaskManager;
import org.objectweb.dream.control.activity.task.TaskStoppedListener;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.objectweb.fractal.julia.control.binding.UseBindingControllerMixin
 * @see org.objectweb.dream.control.logger.UseLoggerControllerMixin
 * @see org.objectweb.dream.control.activity.task.LoggableTaskMixin
 * @see org.objectweb.dream.control.activity.task.BasicTaskControllerMixin
 * @see org.objectweb.dream.control.activity.task.BasicTaskActivationMixin
 * @see org.objectweb.dream.control.activity.task.UseTaskActivationControllerMixin
 * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin
 * @see org.objectweb.dream.control.activity.task.LifeCycleActivationTaskMixin
 */
public class TaskControllerImpl implements TaskActivationController , TaskController , Loggable , Controller , Generated {
    /** 
     * @see org.objectweb.dream.control.activity.task.LifeCycleActivationTaskMixin#addTask(org.objectweb.dream.control.activity.task.Task,java.util.Map)
     */
    public void addTask(Task task, Map hints) throws IllegalTaskException {
        addTask$0(task ,hints);
        if (((weaveableOptLC) == null) || (weaveableOptLC.getFcState().equals(LifeCycleController.STARTED))) {
            try {
                weaveableTAC.activateTask(task);
            } catch (NoSuchTaskException e) {
                org.objectweb.dream.util.Error.bug(null ,e);
            }
        } 
    }
    
    /** 
     * @see org.objectweb.dream.control.activity.task.LoggableTaskMixin#weaveableTCLogger
     */
    public Logger weaveableTCLogger;
    
    /** 
     * @see org.objectweb.dream.control.logger.UseLoggerControllerMixin#weaveableOptLogC
     */
    public LoggerController weaveableOptLogC;
    
    /** 
     * @see org.objectweb.dream.control.activity.task.LoggableTaskMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$2(final InitializationContext ic) throws InstantiationException {
        initFcController$3(ic);
        weaveableTCLogger = NullLogger.NULL_LOGGER;
        if ((weaveableOptLogC) != null) {
            ((LoggerControllerRegister)(weaveableOptLogC)).register("task-controller" ,this);
        } 
    }
    
    /** 
     * @see org.objectweb.dream.control.activity.task.BasicTaskControllerMixin#taskRegistrationHints
     */
    protected Map<org.objectweb.dream.control.activity.task.Task, java.util.Map<java.lang.String, ?>>  taskRegistrationHints;
    
    /** 
     * @see org.objectweb.dream.control.activity.task.UseTaskActivationControllerMixin#weaveableTAC
     */
    public TaskActivationController weaveableTAC;
    
    /** 
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$5(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.objectweb.dream.control.activity.task.BasicTaskActivationMixin#activateTask(org.objectweb.dream.control.activity.task.Task)
     */
    public void activateTask(Task task) throws IllegalTaskException, NoSuchTaskException {
        if (!(taskRegistrationHints.containsKey(task))) {
            throw new NoSuchTaskException(task);
        } 
        weaveableTCLogger.log(BasicLevel.DEBUG ,"register a task");
        Map hints = ((Map)(taskRegistrationHints.get(task)));
        TaskManager tmc = getTaskManagerBinding();
        try {
            tmc.registerTask(task ,hints);
        } catch (Exception e) {
            throw new IllegalTaskException(task , "Unable to register task" , e);
        }
        weaveableTCLogger.log(BasicLevel.DEBUG ,"task registered");
    }
    
    /** 
     * @see org.objectweb.dream.control.logger.UseLoggerControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$3(final InitializationContext ic) throws InstantiationException {
        try {
            weaveableOptLogC = ((LoggerController)(ic.getInterface("logger-controller")));
        } catch (InstantiationException e) {
            weaveableOptLogC = null;
        }
        initFcController$4(ic);
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.binding.UseBindingControllerMixin#weaveableBC
     */
    public BindingController weaveableBC;
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#weaveableOptLC
     */
    public LifeCycleController weaveableOptLC;
    
    /** 
     * @see org.objectweb.dream.control.activity.task.UseTaskActivationControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
        weaveableTAC = ((TaskActivationController)(ic.getInterface("task-activation-controller")));
        initFcController$1(ic);
    }
    
    /** 
     * @see org.objectweb.dream.control.activity.task.BasicTaskControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$1(final InitializationContext ic) throws InstantiationException {
        initFcController$2(ic);
        taskRegistrationHints = java.util.Collections.synchronizedMap(new HashMap<org.objectweb.dream.control.activity.task.Task, java.util.Map<java.lang.String, ?>> ());
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.binding.UseBindingControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$4(final InitializationContext ic) throws InstantiationException {
        weaveableBC = ((BindingController)(ic.getInterface("binding-controller")));
        initFcController$5(ic);
    }
    
    /** 
     * @see org.objectweb.dream.control.activity.task.LifeCycleActivationTaskMixin#removeTask(org.objectweb.dream.control.activity.task.Task)
     */
    public void removeTask(Task task) throws IllegalTaskException, NoSuchTaskException {
        weaveableTAC.deactivateTask(task);
        removeTask$0(task);
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        weaveableOptLC = ((LifeCycleController)(ic.getOptionalInterface("lifecycle-controller")));
        initFcController$0(ic);
    }
    
    /** 
     * @see org.objectweb.dream.control.activity.task.LoggableTaskMixin#setLogger(java.lang.String,org.objectweb.util.monolog.api.Logger)
     */
    public void setLogger(String name, Logger logger) {
        if ("task-controller".equals(name)) {
            weaveableTCLogger = logger;
        } 
    }
    
    /** 
     * @see org.objectweb.dream.control.activity.task.BasicTaskActivationMixin#deactivateTask(org.objectweb.dream.control.activity.task.Task)
     */
    public void deactivateTask(Task task) throws IllegalTaskException, NoSuchTaskException {
        if (!(taskRegistrationHints.containsKey(task))) {
            throw new NoSuchTaskException(task);
        } 
        weaveableTCLogger.log(BasicLevel.DEBUG ,"deactivate a task");
        try {
            getTaskManagerBinding().unregisterTask(task);
        } catch (IllegalTaskException e) {
            weaveableTCLogger.log(BasicLevel.DEBUG ,"task already deactivated");
        } catch (Exception e) {
            throw new IllegalTaskException(task , "Unable to unregister task" , e);
        }
        weaveableTCLogger.log(BasicLevel.DEBUG ,"task deactivated");
    }
    
    /** 
     * @see org.objectweb.dream.control.activity.task.BasicTaskControllerMixin#getTasks()
     */
    public Task[] getTasks() {
        Task[] tasks = new Task[taskRegistrationHints.keySet().size()];
        return taskRegistrationHints.keySet().toArray(tasks);
    }
    
    private void initFcController$6(InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.objectweb.dream.control.activity.task.BasicTaskControllerMixin#addTask(org.objectweb.dream.control.activity.task.Task,java.util.Map)
     */
    private void addTask$0(Task task, Map<java.lang.String, java.lang.Object>  hints) throws IllegalTaskException {
        if (taskRegistrationHints.containsKey(task)) {
            throw new IllegalTaskException(task , "The given task has already been added in the task controller" , null);
        } 
        taskRegistrationHints.put(task ,hints);
    }
    
    private void addTask$1(Task task, Map hints) throws IllegalTaskException {
    }
    
    /** 
     * @see org.objectweb.dream.control.activity.task.BasicTaskControllerMixin#removeTask(org.objectweb.dream.control.activity.task.Task)
     */
    private void removeTask$0(Task task) throws IllegalTaskException, NoSuchTaskException {
        if (!(taskRegistrationHints.containsKey(task))) {
            throw new NoSuchTaskException(task);
        } 
        weaveableTCLogger.log(BasicLevel.DEBUG ,"remove a task");
        try {
            taskRegistrationHints.remove(task);
        } catch (Exception e) {
            throw new IllegalTaskException(task , "Unable to unregister task" , e);
        }
        weaveableTCLogger.log(BasicLevel.DEBUG ,"task removed");
    }
    
    private void removeTask$1(Task task) throws IllegalTaskException, NoSuchTaskException {
    }
    
    /** 
     * @see org.objectweb.dream.control.activity.task.BasicTaskActivationMixin#deactivateTask(org.objectweb.dream.control.activity.task.Task,org.objectweb.dream.control.activity.task.TaskStoppedListener)
     */
    public void deactivateTask(Task task, TaskStoppedListener taskStoppedListener) throws IllegalTaskException, NoSuchTaskException {
        if (!(taskRegistrationHints.containsKey(task))) {
            throw new NoSuchTaskException(task);
        } 
        weaveableTCLogger.log(BasicLevel.DEBUG ,"deactivate a task");
        try {
            getTaskManagerBinding().interruptTask(task ,new TaskActivationStoppedListener(taskStoppedListener));
        } catch (IllegalTaskException e) {
            weaveableTCLogger.log(BasicLevel.DEBUG ,"task already deactivated");
            taskStoppedListener.taskStopped(task);
        } catch (Exception e) {
            throw new IllegalTaskException(task , "Unable to unregister task" , e);
        }
        weaveableTCLogger.log(BasicLevel.DEBUG ,"task deactivated");
    }
    
    /** 
     * @see org.objectweb.dream.control.activity.task.BasicTaskActivationMixin#getTaskManagerBinding()
     */
    private TaskManager getTaskManagerBinding() throws IllegalTaskException {
        try {
            return ((TaskManager)(weaveableBC.lookupFc("task-manager")));
        } catch (NoSuchInterfaceException e) {
            throw new IllegalTaskException(null , "This component has no task-manager client interface" , null);
        }
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.TaskControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.objectweb.fractal.julia.control.binding.UseBindingControllerMixin org.objectweb.dream.control.logger.UseLoggerControllerMixin org.objectweb.dream.control.activity.task.LoggableTaskMixin org.objectweb.dream.control.activity.task.BasicTaskControllerMixin org.objectweb.dream.control.activity.task.BasicTaskActivationMixin org.objectweb.dream.control.activity.task.UseTaskActivationControllerMixin org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin org.objectweb.dream.control.activity.task.LifeCycleActivationTaskMixin)";
    }
    
}

